#include <OneWire.h>
#include <VirtualWire.h>
float valeur = 0;

OneWire  ds(10);  // Mesure sur broche 10 de la carte Arduino

void setup(void) {
  Serial.begin(9600);
  vw_set_tx_pin(2);  //On force l'émission sur la broche 2
  vw_setup(2000);    //Vitesse de transmission (la diminuer pour augmenter la portée ...essais en cours)
  }

void loop(void) {
  byte i;
  byte present = 0;
  byte type_s;
  byte data[12];
  byte addr[8];
  float celsius;
  if ( !ds.search(addr)) {
    
    ds.reset_search();
    delay(250);
    return;
  }
  
    
  switch (addr[0]) {
      case 0x28:
      Serial.println("  Chip = DS18B20");
      type_s = 0;
      break;
      default:
      Serial.println("Le capteur n'est pas un DS1820");
      return;
  } 

  ds.reset();
  ds.select(addr);
  ds.write(0x44, 1);        //Debut traitement Conversion
  
  delay(1000);     
  
  
  present = ds.reset();
  ds.select(addr);    
  ds.write(0xBE);         // Lecture capteur
  
  for ( i = 0; i < 9; i++) {           // Il nous faut 9Bytes
    data[i] = ds.read();
      }
  
  int16_t raw = (data[1] << 8) | data[0];
  if (type_s) {
    raw = raw << 3; // 9 bit resolution default
    if (data[7] == 0x10) {
      
      raw = (raw & 0xFFF0) + 12 - data[6];
    }
  } else {
    byte cfg = (data[4] & 0x60);
    // si basse resolution les bits de poids faibles sont à 0
    if (cfg == 0x00) raw = raw & ~7;  // 9 bit resolution, 93.75 ms
    else if (cfg == 0x20) raw = raw & ~3; // 10 bit res, 187.5 ms
    else if (cfg == 0x40) raw = raw & ~1; // 11 bit res, 375 ms
    //// resolution 12 bits par defaut
  }
  celsius = (float)raw / 16.0;
  //////////////////////////////////////////////////////////////
  /// C'est la partie Emission //////
  //////////////////////////////////////////////////////////////
 valeur = celsius;
   Serial.println(valeur);
  vw_send((byte *) &valeur, sizeof(valeur)); 
  delay(2000);
  vw_wait_tx(); // On
  delay(5000);
}
